#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <cstdio>
#define MAXN 300000

using namespace std;

struct point{int id,x,y;};

map<int,int>ys; int xsn = 1;
map<int,int>xs; int ysn = 1;
map<pair<int,int>,vector<int>>pid;
vector<vector<point>>hl(1,vector<point>(0));
vector<vector<point>>hr(1,vector<point>(0));
vector<vector<point>>hu(1,vector<point>(0));
vector<vector<point>>hd(1,vector<point>(0));
bool del[MAXN];
int id = 1, cu, cd, cl, cr;

bool cmpl(point p, point q){ return p.x > q.x; }
bool cmpr(point p, point q){ return p.x < q.x; }
bool cmpu(point p, point q){ return p.y > q.y; }
bool cmpd(point p, point q){ return p.y < q.y; }

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("triangle00.in","r",stdin);
    //freopen("triangle00.out","w",stdout);

    int command = 1, x, y, temp;
    point p;

    int N, Q;

    cin >> N >> Q;

    for(int i = 0; i < N; ++i)
    {
        cin >> x >> y;
        p.x=x;
        p.y=y;
        p.id=id;
        pid[pair<int,int>(x,y)].push_back(id++);
        temp = xs[x];
        if(!temp)
        {
            temp = xs[x] = xsn++;
            hu.push_back(vector<point>(0));
            hd.push_back(vector<point>(0));
        }
        hu[temp].push_back(p); push_heap(hu[temp].begin(),hu[temp].end(),cmpu);
        hd[temp].push_back(p); push_heap(hd[temp].begin(),hd[temp].end(),cmpd);

        temp = ys[y];
        if(!temp)
        {
            temp = ys[y] = ysn++;
            hl.push_back(vector<point>(0));
            hr.push_back(vector<point>(0));
        }
        hl[temp].push_back(p); push_heap(hl[temp].begin(),hl[temp].end(),cmpl);
        hr[temp].push_back(p); push_heap(hr[temp].begin(),hr[temp].end(),cmpr);
    }

    while(Q--)
    {
        cin >> command >> x >> y;
        if(command == 1)
        {
            p.x=x;
            p.y=y;
            p.id=id;
            //cout << "Current ID: " << id << "\n";
            pid[pair<int,int>(x,y)].push_back(id++);
            temp = xs[x];
            if(!temp)
            {
                temp = xs[x] = xsn++;
                hu.push_back(vector<point>(0));
                hd.push_back(vector<point>(0));
            }
            hu[temp].push_back(p); push_heap(hu[temp].begin(),hu[temp].end(),cmpu);
            hd[temp].push_back(p); push_heap(hd[temp].begin(),hd[temp].end(),cmpd);

            temp = ys[y];
            if(!temp)
            {
                temp = ys[y] = ysn++;
                hl.push_back(vector<point>(0));
                hr.push_back(vector<point>(0));
            }
            hl[temp].push_back(p); push_heap(hl[temp].begin(),hl[temp].end(),cmpl);
            hr[temp].push_back(p); push_heap(hr[temp].begin(),hr[temp].end(),cmpr);
        }
        if(command == 2)
        {
            del[pid[pair<int,int>(x,y)].back()]=1;
            //cout << "DELETING: " << pid[pair<int,int>(x,y)].back() << "\n";
            pid[pair<int,int>(x,y)].pop_back();
        }
        if(command == 3)
        {
            temp=xs[x];

            while(!hu[temp].empty() && del[hu[temp].front().id]) { pop_heap(hu[temp].begin(),hu[temp].end(),cmpu); hu[temp].pop_back(); }
            if(hu[temp].empty()) { cout << "0\n"; continue; }
            cu = hu[temp].front().y;

            //for (int j = 0; j < hu[temp].size(); ++j) cout << hu[temp][j].x << " " << hu[temp][j].y  << " " << hu[temp][j].id << "\n";
            //for (int j = 0; j < id; ++j) {if (del[j]) cout << "DELETED: " << j << "\n"; }
            while(!hd[temp].empty() && del[hd[temp].front().id]) { pop_heap(hd[temp].begin(),hd[temp].end(),cmpd); hd[temp].pop_back(); }
            cd = hd[temp].front().y;

            temp=ys[y];

            while(!hl[temp].empty() && del[hl[temp].front().id]) { pop_heap(hl[temp].begin(),hl[temp].end(),cmpl); hl[temp].pop_back(); }
            if(hl[temp].empty()) { cout << "0\n"; continue; }
            cl = hl[temp].front().x;

            while(!hr[temp].empty() && del[hr[temp].front().id]) { pop_heap(hr[temp].begin(),hr[temp].end(),cmpr); hr[temp].pop_back(); }
            cr = hr[temp].front().x;

            long long ans = (long long)max(cr-x,x-cl) * (long long)max(cd-y,y-cu);
            cout << ans / 2 << (ans % 2 ? ".5\n" : "\n");
        }

    }
    return 0;
}
